ORIGIN		= Symantec Caf
ORIGIN_VER	= Version 7.22
VERSION		= DEBUG

!IFDEF SUB_DEBUG
DEBUG		= $(SUB_DEBUG)
NDEBUG		= !$(SUB_DEBUG)
!ELSE
DEBUG		= 1
NDEBUG		= 0
!ENDIF

PROJ		= SunStarts
APPTYPE		= JAVA CONSOLE
PROJTYPE	= class

JAVAC		= sj
MAKE		= SMAKE
LNK		= LINK


HEADERS		= 
!IF $(DEBUG)
OUTPUTDIR	= .
CREATEOUTPUTDIR	=
TARGETDIR	= .
CREATETARGETDIR	=

CFLAGS		=  -g 
DEFINES		= 
!ELSE
OUTPUTDIR	= .
CREATEOUTPUTDIR	=
TARGETDIR	= .
CREATETARGETDIR	=

CFLAGS		=  -O 
DEFINES		= 
!ENDIF

MFLAGS		= MASTERPROJ=$(PROJ) 
DEBUGGERFLAGS	=  
PAR		= PROJS BATS SRCS

INCLUDES	= 



SRCS		= query\AttrSet.java query\AttrSetBasic1.java query\AttrSetDcore1.java  \
		query\BoolOp.java parsing\Char_Vector.java resource\CSTRDocument.java resource\CSTRSourceDescription.java  \
		parsing\Dequeue.java parsing\DequeueException.java results\Document.java DummyServer.java  \
		query\ExpNode.java query\Field.java query\FilterNode.java http\HTTPHeader.java  \
		parsing\Int_Stack.java parsing\Int_Vector.java parsing\jb.java parsing\jf.java  \
		parsing\LexException.java resource\LINUXDocument.java resource\LINUXSourceDescription.java query\LString.java  \
		regexp\MalformedRegexpException.java query\Modifier.java query\ModifierList.java regexp\NoSuchMatchException.java  \
		parsing\Object_Stack.java parsing\Object_Vector.java parsing\ParseException.java query\ProxOp.java  \
		query\Query.java parsing\Queue.java query\RankingList.java query\RankingNode.java  \
		regexp\Regexp.java regexp\RegexpCompiler.java STARTSConfiguration\ResourceDescription.java regexp\Result.java  \
		results\ResultSet.java server.java STARTSConfiguration\ServerConfiguration.java soif\SOIFException.java  \
		soif\SOIFObject.java resource\SourceDescription.java resource\SourceException.java resource\SourceNode.java  \
		query\SourceQueryException.java query\SourceRanking.java query\STARTSnode.java parsing\subst.java  \
		query\Term.java results\TermStatistics.java query\UnsupportedQueryException.java wais\WAISBoolOp.java  \
		wais\WAISDictionary.java wais\WAISDictionaryTerm.java wais\WAISDocuments.java wais\WAISInvertedIndex.java  \
		wais\WAISProxOp.java wais\WAISRelOp.java wais\WAISResultDocument.java wais\WAISResultSet.java  \
		wais\WAISSearchSend.java wais\WAISSourceDescription.java wais\WAISTermDocInfo.java wais\WAISTermInfo.java  \
		wais\WAISWeightedRanking.java wais\WAISWordLiteral.java query\WeightedRanking.java parsing\YYhash.java  \
		parsing\ranking\YYlex.java parsing\filter\YYlex.java parsing\YYlexbuffer.java parsing\YYlocation.java  \
		parsing\YYnode.java parsing\YYnonterminal.java parsing\ranking\YYparse.java parsing\filter\YYparse.java  \
		parsing\YYterminal.java parsing\YYtoken.java parsing\ranking\YYtokentypes.java parsing\filter\YYtokentypes.java 

BATS		= 

.SUFFIXES: .JAVA .CLASS 

.JAVA.CLASS:
	$(JAVAC) $(CFLAGS) $(INCLUDES) $*.java



all:	noteout createdir $(PRECOMPILE) compall $(POSTCOMPILE) _done


all2:	createdir $(PRECOMPILE) compall $(POSTCOMPILE) _done


all3:	createdir $(PRECOMPILE) compall2 $(POSTCOMPILE) _done


compall:	$(OBJS)
	$(JAVAC) $(CFLAGS) $(INCLUDES) -make -cdb $(PROJ).cdb @<<
	$(SRCS)
<<


compall2:	$(OBJS)
	$(JAVAC) $(CFLAGS) $(INCLUDES) -cdb $(PROJ).cdb @<<
	$(SRCS)
<<

noteout:
	REM Output to $(OUTPUTDIR)

createdir:
	$(CREATEOUTPUTDIR)
	$(CREATETARGETDIR)
	
_done:
		REM  Project is up to date

buildall:	clean	all3


clean:
		-del $(TARGETDIR)\$$SCW$$.$(PROJTYPE)
		-del $(TARGETDIR)\$(PROJ).CLE
		-del SunStarts.dpd
		-del $(OBJS)




