package parsing.ranking;

public
abstract
class YYtokentypes {

public static final int EOF = 0;

public static final int tokenmin = 258;
public static final int tokenmax = 268;

public static Integer[] Tokentype;

static
{
  Tokentype = new Integer[tokenmax+1];
  for(int i=0;i<=tokenmax;i++) {Tokentype[i] = new Integer(i);}
}

public static final Integer YYEOF = Tokentype[EOF];

public static final Integer BOOLEANOP = YYtokentypes.Tokentype[258];
public static final Integer PROX = YYtokentypes.Tokentype[259];
public static final Integer INTEGER_LITERAL = YYtokentypes.Tokentype[260];
public static final Integer DECIMAL_LITERAL = YYtokentypes.Tokentype[261];
public static final Integer BOOLEANVAL = YYtokentypes.Tokentype[262];
public static final Integer QUOTED_STRING = YYtokentypes.Tokentype[263];
public static final Integer LANGUAGE_CODE = YYtokentypes.Tokentype[264];
public static final Integer UNQUOTED_STRING = YYtokentypes.Tokentype[265];
public static final Integer RELATION = YYtokentypes.Tokentype[266];
public static final Integer MODIFIER = YYtokentypes.Tokentype[267];
public static final Integer LIST = YYtokentypes.Tokentype[268];


public static final String tokennames[] = {
"BOOLEANOP",
"PROX",
"INTEGER_LITERAL",
"DECIMAL_LITERAL",
"BOOLEANVAL",
"QUOTED_STRING",
"LANGUAGE_CODE",
"UNQUOTED_STRING",
"RELATION",
"MODIFIER",
"LIST",
null
};

public static String tokenname(Integer t)
{return tokenname(t==null?EOF:t.intValue());}

public static String tokenname(int t)
{
    if(t >= tokenmin && t <= tokenmax) {
	return tokennames[t - tokenmin];
    } else if(t > 0 && t <= 255) {
	return "'" + String.valueOf((char)t) + "'";
    } else if(t == EOF) {
	return "EOF";
    } else {
	return "$undefined$";
    }
}

//////////////////////////////////////////////////

public static final int nontermmin = 269;
public static final int nontermmax = 286;

public static final int nt_ranking = 269;
public static final int nt_ranking_list = 270;
public static final int nt_w_ranking_list = 271;
public static final int nt_w_ranking = 272;
public static final int nt_booleanop = 273;
public static final int nt_prox_op = 274;
public static final int nt_digit = 275;
public static final int nt_decimal_digit = 276;
public static final int nt_booleanval = 277;
public static final int nt_term = 278;
public static final int nt_lstring = 279;
public static final int nt_field = 280;
public static final int nt_modifier_list = 281;
public static final int nt_modifier = 282;
public static final int nt_attribute_set = 283;
public static final int nt_field_spec = 284;
public static final int nt_language_code = 285;
public static final int nt_quoted_string = 286;


public static final String nontermnames[] = {
"ranking",
"ranking_list",
"w_ranking_list",
"w_ranking",
"booleanop",
"prox_op",
"digit",
"decimal_digit",
"booleanval",
"term",
"lstring",
"field",
"modifier_list",
"modifier",
"attribute_set",
"field_spec",
"language_code",
"quoted_string",
null
};

public static String nontermname(int t)
{
    if(t >= nontermmin && t <= nontermmax) {
	return nontermnames[t - nontermmin];
    } else {
	return "$undefined$";
    }
}

//////////////////////////////////////////////////
};
