/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package query;

/**
 * Interface to declare methods comon to all ExpNodes that appear
 * within filter expression.
 */
public interface FilterNode {

    /**
     * Return the ExpNode that represents the source version of this
     * ExpNode in the context of a filter expression.
     * @return the sub-tree that is the source translated version of
     * this filter sub-tree.
     * @exception SourceQueryException if there are errors in the
     * translation process.
     */
    public ExpNode TranslateToFilter() throws SourceQueryException;
}
