/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package query;

/**
 * Interface to encapsulates methods to all ExpNodes for STARTS
 * filter and ranking expressions.
 */
public interface STARTSnode {

    /**
     * Check the subtree descending from this STARTS node for
     * semantic inconsistencies and source support.
     * @return the transformed sub-tree as a result of the semantic
     * checking operation.
     * @exception UnsupportedQueryException if an error is discovered
     * during the checking process.
     */
    public ExpNode Check() throws UnsupportedQueryException;

}
