/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package resource;

import results.*;

/**
 * Interface to encapsulate methods in common for Source specific
 * ExpNodes
 */
public interface SourceNode {

    /**
     * Return a float value that is the result of ranking a document
     * by the sub-tree that descends from this ExpNode
     * @param doc  the Document to rank
     * @return the ranking value of the document.
     */
    public float RankBy(Document doc);

}
