/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package wais;

import resource.*;

/**
 * The native link to the c-based waissearch code
 */
public class WAISSearchSend {

    /* !!!!! PLATFORM SPECIFIC CODE !!!!! */

    /**
     * Perform a search on the native WAIS search engine
     * @param  host    host name where the WAIS search engine is
     * running.
     * @param port port on which the WAIS search engine is available
     * @param dataBase WAIS database on which to perform the search
     * @param search   The search string.
     */
    public native static String[] SearchWAIS(String host, String port,
        String dataBase, String search) throws SourceException;

   /* !!!!! SOLARIS VERSION !!!!! */

  static {
	  System.load("/home/lagoze/projects/starts/StartsServer/wais/SearchWais.so");
  }

  /* !!!!! NO NT VERSION !!!!! */
  /* !!!!! END PLATFORM SPECIFIC CODE !!!!! */
}
