/**********************************************************************
 *                              STARTS                                *
 *      Stanford Protocol for Internet Retrieval and Search           *
 *                                                                    *
 *                      Reference Implementation                      *
 *                                                                    *
 *                           Carl Lagoze                              *
 *                      lagoze@cs.cornell.edu                         *
 *                   Department of Computer Science                   *
 *                        Cornell University                          *
 *********************************************************************/

package wais;

/**
 * Container for source-wide informatin for WAIS terms
 */
public class WAISTermInfo {

    /**
     * Number of documents this term appears in
     */
    int documentFrequency;

    /**
     * total number of occurrences of this term in the source
     */
    int totalOccs;

    /**
     * Construct a new WAISTermInfo
     * @param documentFrequency Number of documents this term
     * appears in
     * @param totalOccs total number of occurrences of this
     * term in the source
     */
    public WAISTermInfo(int documentFrequency, int totalOccs) {
        this.documentFrequency = documentFrequency;
        this.totalOccs = totalOccs;
    }

    /**
     * Return the number of documents this term appears in
     */
    public int GetDocumentFrequency() {
        return(documentFrequency);
    }

    /**
     * Return the number of occurrences of this term in the source.
     */
    public int GettotalOccs() {
        return(totalOccs);
    }
}
